WalkingJumpFlySpeed = {};

WalkingJumpFlySpeed.metadata = {
	interface = " FS19 1.x",
	title = " WalkingJumpFly Speed",
	notes = " Ändert/Setzt/Aktiviert Player/Fly/Walking Speed",
	author = " (by HappyLooser)",
	version = " v0.2 Beta",
	datum = " 20.11.2018",
	update = " 15.12.2018",
	web = " no",
	info = " Link Freigabe,Änderungen,Kopien oder Code Benutzung ist ohne meine Zustimmung nicht erlaubt",
	"##Orginal Link Freigabe:"
};

WalkingJumpFlySpeed.modDir = g_currentModDirectory;
function WalkingJumpFlySpeed:loadMap(name)
	g_currentMission.walkingJumpFlySpeed = WalkingJumpFlySpeed;	
	print("---loading".. tostring(WalkingJumpFlySpeed.metadata.title).. tostring(WalkingJumpFlySpeed.metadata.version).. tostring(WalkingJumpFlySpeed.metadata.author).. "---")
	if g_server ~= nil and g_client ~= nil and g_dedicatedServerInfo ~= nil then return;end;
	WalkingJumpFlySpeed.settingsDir = getUserProfileAppPath().. "modsSettings/WalkingJumpFlySpeed/";	
	WalkingJumpFlySpeed.rebootXml = false;
	WalkingJumpFlySpeed.hlDebugMode = false;
	WalkingJumpFlySpeed.default = {mpFlyIsReady=false, setFlyModeMP=false, printFlyNoHudHelp=true, printFlyNoHudStatus=true, inGameHelpText=true, setFlyNoHudModeOverMod=false, jumpHeight=1.5, walkingSpeed=4, runningSpeed=9};
	--WalkingJumpFlySpeed.default.mpFlyIsReady = WalkingJumpFlySpeed.default.setFlyModeMP;
	WalkingJumpFlySpeed:setGetCfg(true);	
	WalkingJumpFlySpeed.isLoadMap = false;
	WalkingJumpFlySpeed:init();	
end;

function WalkingJumpFlySpeed:deleteMap()
	if g_server ~= nil and g_client ~= nil and g_dedicatedServerInfo ~= nil then return;end;
	WalkingJumpFlySpeed:setGetCfg(false);	
end;

function WalkingJumpFlySpeed:mouseEvent(posX, posY, isDown, isUp, button)	
end;

function WalkingJumpFlySpeed:keyEvent(unicode, sym, modifier, isDown)
	if g_server ~= nil and g_client ~= nil and g_dedicatedServerInfo ~= nil then return;end;
	if WalkingJumpFlySpeed.rebootXml and Input.isKeyPressed(Input.KEY_esc) then
		if g_currentMission.inGameMenu.isOpen then WalkingJumpFlySpeed:setGetCfg(true);WalkingJumpFlySpeed:setNewValues();end;		
	end;
	if WalkingJumpFlySpeed:getFullSize(self) or WalkingJumpFlySpeed:getIngameMap() then return;end;
	if WalkingJumpFlySpeed.default.setFlyNoHudModeOverMod then WalkingJumpFlySpeed:setFlyNoHudModeOverMod();end;
end;

function WalkingJumpFlySpeed:update(dt)
	if g_server ~= nil and g_client ~= nil and g_dedicatedServerInfo ~= nil then return;end;
	if not WalkingJumpFlySpeed.isLoadMap then 
		WalkingJumpFlySpeed.isLoadMap = true;
		if WalkingJumpFlySpeed.default.setFlyModeMP and not g_currentMission.player.isOwner then
			addConsoleCommand("gsToggleFlightAndNoHUDMode", "Toggle debug mode for Jump", "consoleCommandToggleFlightAndNoHUDMode");
			WalkingJumpFlySpeed.default.mpFlyIsReady = true;
		end;
		WalkingJumpFlySpeed:setNewValues();		
	end;	
end;

function WalkingJumpFlySpeed:draw(dt)	
end;

function WalkingJumpFlySpeed:init()
	--source(WalkingJumpFlySpeed.modDir.."_hl.lua");
end;
addModEventListener(WalkingJumpFlySpeed);

function WalkingJumpFlySpeed:get_hl(args, argsTable, errorTxtCall) --args hl table, argsTable a table with all args Values, errorTxt a Value for debug print
	local isOkay, result, argsError, errorTxt = nil,nil,nil,errorTxtCall;
	if WalkingJumpFlySpeed.hlDebugMode and (errorTxtCall == nil or type(errorTxtCall) ~= "string" or string.len(errorTxtCall) == 0) then errorTxt = "Unknown";end;
	local foundArgsError = false;
	if type(argsTable) == "table" or g_currentMission.hl[args] ~= nil or #argsTable > 0 then	
		isOkay, result = pcall(g_currentMission.hl[args], unpack(argsTable));
	else
		foundArgsError = true;
	end;
	if WalkingJumpFlySpeed.hlDebugMode and foundArgsError then isOkay=false;argsError="Unknown args or argsTable or argsTable = 0";end;		
	if WalkingJumpFlySpeed.hlDebugMode and (not isOkay or foundArgsError) then WalkingJumpFlySpeed:setDebug("WalkingJumpFlySpeedMod", args or "Unknown", errorTxt, argsError or "No args error", result or "NO result error");end;
	return result, isOkay;	
end;

function WalkingJumpFlySpeed:setDebug(argsMod, args1, errorTxt, args2, args3)	
	if g_currentMission.hl.debug == nil then g_currentMission.hl.debug = {};end;
	if g_currentMission.hl.debug[argsMod] == nil then g_currentMission.hl.debug[argsMod] = {};end;
	local errorString = "Trigger: ".. tostring(args1).. " -errorTxtCall: ".. tostring(errorTxt).. " -argsError: ".. tostring(args2).. " -resultError: ".. tostring(args3);
	local alreadyExists = false;
	if #g_currentMission.hl.debug[argsMod] == 0 then table.insert(g_currentMission.hl.debug[argsMod], tostring(errorString));else
		for key,value in pairs(g_currentMission.hl.debug[argsMod]) do			
			if tostring(value) == errorString and string.len(value) == string.len(errorString) then alreadyExists=true;break;end;			
		end;		
		if not alreadyExists then table.insert(g_currentMission.hl.debug[argsMod], tostring(errorString));end;
	end;	
end;

function WalkingJumpFlySpeed:setGetCfg(loadCfg)
	createFolder(getUserProfileAppPath().. "modsSettings/");
	createFolder(WalkingJumpFlySpeed.settingsDir);
	local file = WalkingJumpFlySpeed.settingsDir.. "walkingJumpFlySpeedSettings.xml";
	local Xml = nil;
	local xmlVersion = 0.1;
	if not fileExists(file) or not loadCfg then
		Xml = createXMLFile("WalkingJumpFlySpeed_XML", file, "walkingJumpFlySpeedSettings");		
		local groupNameTag = ("walkingJumpFlySpeedSettings.version(%d)"):format(0);
		setXMLString(Xml, groupNameTag.. "#xmlVersion", tostring(xmlVersion));
		local groupNameTag = ("walkingJumpFlySpeedSettings.global(%d)"):format(0);
		setXMLBool(Xml, groupNameTag.. "#rebootXmlESC", WalkingJumpFlySpeed.rebootXml);
		setXMLFloat(Xml, groupNameTag.. "#jumpHeight", WalkingJumpFlySpeed.default.jumpHeight);		
		setXMLFloat(Xml, groupNameTag.. "#walkingSpeed", WalkingJumpFlySpeed.default.walkingSpeed);
		setXMLFloat(Xml, groupNameTag.. "#runningSpeed", WalkingJumpFlySpeed.default.runningSpeed);
		setXMLBool(Xml, groupNameTag.. "#setFlyNoHudModeOverMod", WalkingJumpFlySpeed.default.setFlyNoHudModeOverMod);
		setXMLBool(Xml, groupNameTag.. "#setFlyModeMP", WalkingJumpFlySpeed.default.setFlyModeMP);
		setXMLBool(Xml, groupNameTag.. "#printFlyNoHudHelp", WalkingJumpFlySpeed.default.printFlyNoHudHelp);
		setXMLBool(Xml, groupNameTag.. "#printFlyNoHudStatus", WalkingJumpFlySpeed.default.printFlyNoHudStatus);
		setXMLBool(Xml, groupNameTag.. "#inGameHelpText", WalkingJumpFlySpeed.default.inGameHelpText);
		--setXMLBool(Xml, groupNameTag.. "#hlDebugMode", WalkingJumpFlySpeed.default.hlDebugMode);	
		saveXMLFile(Xml);
	else	
		Xml = loadXMLFile("WalkingJumpFlySpeed_XML", file, "walkingJumpFlySpeedSettings");
		local groupNameTag = ("walkingJumpFlySpeedSettings.version(%d)"):format(0);
		if not getXMLString(Xml, groupNameTag.. "#xmlVersion") then WalkingJumpFlySpeed:saveOldXml();WalkingJumpFlySpeed:setGetCfg(false)return;end;
		local xmlVersionTemp = string.format("%1.1f", "".. getXMLString(Xml, groupNameTag.. "#xmlVersion"));		
		if tonumber(xmlVersionTemp) < tonumber(xmlVersion) then WalkingJumpFlySpeed:saveOldXml();WalkingJumpFlySpeed:setGetCfg(false)return;end;
		local groupNameTag = ("walkingJumpFlySpeedSettings.global(%d)"):format(0);
		if getXMLBool(Xml, groupNameTag.. "#rebootXmlESC") ~= nil then WalkingJumpFlySpeed.rebootXml = getXMLBool(Xml, groupNameTag.. "#rebootXmlESC");end;
		if getXMLFloat(Xml, groupNameTag.. "#jumpHeight") then WalkingJumpFlySpeed.default.jumpHeight = getXMLFloat(Xml, groupNameTag.. "#jumpHeight");end;		
		if getXMLFloat(Xml, groupNameTag.. "#walkingSpeed") then WalkingJumpFlySpeed.default.walkingSpeed = getXMLFloat(Xml, groupNameTag.. "#walkingSpeed");end;
		if getXMLFloat(Xml, groupNameTag.. "#runningSpeed") then WalkingJumpFlySpeed.default.runningSpeed = getXMLFloat(Xml, groupNameTag.. "#runningSpeed");end;
		if getXMLBool(Xml, groupNameTag.. "#setFlyNoHudModeOverMod") ~= nil then WalkingJumpFlySpeed.default.setFlyNoHudModeOverMod = getXMLBool(Xml, groupNameTag.. "#setFlyNoHudModeOverMod");end;
		if getXMLBool(Xml, groupNameTag.. "#setFlyModeMP") ~= nil then WalkingJumpFlySpeed.default.setFlyModeMP = getXMLBool(Xml, groupNameTag.. "#setFlyModeMP");end;
		if getXMLBool(Xml, groupNameTag.. "#printFlyNoHudHelp") ~= nil then WalkingJumpFlySpeed.default.printFlyNoHudHelp = getXMLBool(Xml, groupNameTag.. "#printFlyNoHudHelp");end;
		if getXMLBool(Xml, groupNameTag.. "#printFlyNoHudStatus") ~= nil then WalkingJumpFlySpeed.default.printFlyNoHudStatus = getXMLBool(Xml, groupNameTag.. "#printFlyNoHudStatus");end;
		if getXMLBool(Xml, groupNameTag.. "#inGameHelpText") ~= nil then WalkingJumpFlySpeed.default.inGameHelpText = getXMLBool(Xml, groupNameTag.. "#inGameHelpText");end;
		--if getXMLBool(Xml, groupNameTag.. "#hlDebugMode") ~= nil then WalkingJumpFlySpeed.hlDebugMode = getXMLBool(Xml, groupNameTag.. "#hlDebugMode");end;
	end;	
end;

function WalkingJumpFlySpeed:saveOldXml()	
	local getDateString = tostring(getDate("%d").. "_".. getDate("%w").. "_".. getDate("%m").. "_".. getDate("%Y"));
	local oldXml = WalkingJumpFlySpeed.settingsDir.. "walkingJumpFlySpeedSettings.xml";	
	local backupXml = WalkingJumpFlySpeed.settingsDir.. "walkingJumpFlySpeedSettings_Old_Backup_".. getDateString.. ".xml";	
	copyFile(oldXml, backupXml, false);
end;

function WalkingJumpFlySpeed:setNewValues()		
	g_currentMission.player.motionInformation.jumpHeight = WalkingJumpFlySpeed.default.jumpHeight;
	g_currentMission.player.motionInformation.maxWalkingSpeed = WalkingJumpFlySpeed.default.walkingSpeed;
	g_currentMission.player.motionInformation.maxRunningSpeed = WalkingJumpFlySpeed.default.runningSpeed;
	if WalkingJumpFlySpeed.default.setFlyModeMP and not WalkingJumpFlySpeed.default.mpFlyIsReady and not g_currentMission.player.isOwner then
		addConsoleCommand("gsToggleFlightAndNoHUDMode", "Toggle debug mode for Jump", "consoleCommandToggleFlightAndNoHUDMode");
		WalkingJumpFlySpeed.default.mpFlyIsReady = true;
	elseif not WalkingJumpFlySpeed.default.setFlyModeMP and WalkingJumpFlySpeed.default.mpFlyIsReady and not g_currentMission.player.isOwner then
		removeConsoleCommand("gsToggleFlightAndNoHUDMode");
		WalkingJumpFlySpeed.default.mpFlyIsReady = false;
	end;
end;

function WalkingJumpFlySpeed:getIngameMap()
	return g_gameSettings:getValue("ingameMapState") == 1;	
end;

function WalkingJumpFlySpeed:setFlyNoHudModeOverMod()
	if Input.isKeyPressed(Input[g_inputBinding.nameActions["WalkingJumpFlySpeed"].primaryKeyboardInput]) then		
		Player:consoleCommandToggleFlightAndNoHUDMode();		
		if WalkingJumpFlySpeed.default.printFlyNoHudStatus then 
			print("PlayerFlightAndNoHUDMode over Mod = " .. tostring(g_flightAndNoHUDKeysEnabled));			
		end;
		if not g_flightAndNoHUDKeysEnabled then 
			g_currentMission.player.debugFlightMode = false;			
		elseif WalkingJumpFlySpeed.default.inGameHelpText then
			g_currentMission.hud:showInGameMessage(tostring(WalkingJumpFlySpeed.metadata.title).. " Help Text", "Internal Fly Modus On/Off     'J'\nFly Modus UP/Down     'Q and E'\nNoHud Modus On/Off     'O'\n!! Germany Keyboard !!", -1);
		end;
		if g_flightAndNoHUDKeysEnabled and WalkingJumpFlySpeed.default.printFlyNoHudHelp then
			print("PlayerFlightAndNoHUDMode over Mod Help \nInternal Fly Modus On/Off     'J'\nFly Modus UP/Down     'Q and E'\nNoHud Modus On/Off     'O'\n!! Germany Keyboard !!");
		end;		
	end;
end;

function WalkingJumpFlySpeed:getFullSize(self)
	if g_currentMission.paused or
	g_currentMission.inGameMenu.paused or	
	g_currentMission.inGameMenu.isOpen or 
	g_currentMission.physicsPaused then
	if g_currentMission.missionDynamicInfo.isMultiplayer and g_currentMission.manualPaused then return false;end;
	return true;end;
	return false;
end;